;Sound blaster port read emulation
;Copyright 1995 Kayma software

mov dx,ss:[ebp+20]
mov al,ss:[ebp+28]
cmp dx,022ch
je _22cr	;Command/Data register
cmp dx,022eh
je _22er	;Data avail register
cmp dx,022ah
je _22ar	;Read data register
cmp dx,0228h
je _228r	;Fm status/address
cmp dx,0229h
je _229r
cmp dx,0226h
je _226r	;Reset register
cmp dx,3
je _pt03r
cmp dx,2
je _pt02r
in al,dx
mov ss:[ebp+28],al
jmp _ngetback

_pt02r:
cmp sb_dmarun,1
jne _novirt02
xor bh,bh
mov bl,dma_lnflip
mov eax,dword ptr dma_base
movzx ecx,movedma
add eax,ecx
movzx ecx,_movedma
sub eax,ecx
shl bl,3
mov cl,bl
shr eax,cl
mov ss:[ebp+28],al
xor dma_lnflip,1
jmp _ngetback

_novirt02:
in al,02h
mov ss:[ebp+28],al
jmp _ngetback

_pt03r:
cmp sb_dmarun,1
jne _novirt03
cmp dma_finish,1
je _nivi
xor bh,bh
mov bl,dma_lnflip
mov al,_movedma[bx]
mov ss:[ebp+28],al
xor dma_lnflip,1
jmp _ngetback

_nivi:
mov al,0ffh
mov ss:[ebp+28],al
jmp _ngetback

_novirt03:
in al,03h
mov ss:[ebp+28],al
jmp _ngetback

_bckminus:
mov sb_dmarun,0
mov al,0ffh
mov ss:[ebp+28],al
jmp _ngetback

_226r:
mov byte ptr ss:[ebp+28],0FFh
jmp _ngetback

_22cr:
mov byte ptr ss:[ebp+28],02Ah	;Read 2Ah when ready
;mov byte ptr ss:[ebp+44],0
jmp _ngetback

_22er:
mov byte ptr ss:[ebp+28],0AAh	;AA=Data available
jmp _ngetback

_22ar:			;SB data register
mov al,ds:sb_lastdcmd
cmp al,0E1h
je _readversion		;Read sound blaster version
cmp al,0E0h
je _dsp_idread		;Dsp Id
mov byte ptr ss:[ebp+28],0AAh
jmp _ngetback
_readversion:
cmp ds:sb_datareq,0
je _nodecrement
dec ds:sb_datareq
_nodecrement:
jz _lastbyte
mov byte ptr ss:[ebp+28],1
;mov cl,0
;add cl,1
;lahf
;mov byte ptr ss:[ebp+44],ah
jmp _ngetback
_lastbyte:
mov byte ptr ss:[ebp+28],5
;mov cl,0
;add cl,5
;lahf
;mov byte ptr ss:[ebp+44],ah
jmp _ngetback

_dsp_idread:
mov cl,255
mov al,ds:sb_lastdata
sub cl,al
;lahf
mov byte ptr ss:[ebp+28],cl
;mov byte ptr ss:[ebp+44],ah
mov ds:sb_datareq,0
jmp _ngetback

_228r:
mov byte ptr ss:[ebp+28],0C0h
jmp _ngetback

_229r:
mov byte ptr ss:[ebp+28],0ffh
jmp _ngetback
