;Virtual memory management for Kernel system
;Copyright 1996, Manitou Software (1993)

cli
push ds
push es
pushad
mov ax,010h
mov ds,ax
mov ax,018h
mov es,ax
cmp vmsize,0
je _pagefault
mov eax,cr2
cmp eax,phismem
jb _pagefault
;mov ah,5
;mov ebx,cr2
;int 032h
;****************************
;Increment ages of the pages
;****************************
mov esi,offset age
mov ecx,pagenum
_incages:
mov al,ds:[esi]
cmp al,pagenum
je _noincages
inc byte ptr ds:[esi]
_noincages:
inc esi
loop _incages
;Find the oldest page
mov esi,offset age
xor cx,cx
mov oldest,0
xor dx,dx	;Age of the oldest page
;***********************************
;Find the oldest page
;***********************************
_findoldest:
mov al,ds:[esi]	;AL=age
cmp al,dl
jb _noolder
mov oldest,cl
mov dl,al
_noolder:
inc esi
inc cl
cmp cl,pagenum
jne _findoldest
;Now oldest=the oldest page
xor eax,eax
mov al,oldest
mov esi,offset age
add esi,eax
mov byte ptr ds:[esi],0		;It'll be a new page
shl eax,2
mov esi,offset linaddr
add esi,eax			;The oldest page's linear address
mov eax,ds:[esi]		;Linear address of the page
mov edi,0121000h
and ax,0F000h
shr eax,10
add edi,eax
mov eax,es:[edi]		;This points to the CACHE
mov al,6
mov es:[edi],eax		;Set not present
mov al,7
mov edi,(0121000h+0d1h*4)
mov es:[edi],eax		;D100:1000 points to the cache page
mov actpage,eax
xor eax,eax
mov al,oldest
shl eax,2
mov esi,offset linaddr
add esi,eax
mov eax,ds:[esi]
and ax,0F000h			;Linear addr of the old page
mov ebx,phismem
sub eax,ebx			;EAX=disk position ex.5mb-3.6=1.2mb disk pos.
mov edi,eax
mov ah,4
mov esi,0120000h
mov cr3,esi
int 033h			;Save this page
xor eax,eax
mov al,oldest
shl eax,2
mov esi,offset linaddr
add esi,eax			;DS:[ESI]=linaddr to set
mov edx,cr2
and dx,0F000h
mov ds:[esi],edx		;Set new pointer
mov ebx,phismem
mov eax,cr2			;The new page we need
and ax,0F000h
mov ecx,eax
sub eax,ebx
mov edi,eax			;EAX=disk position
mov eax,ecx
shr eax,10
mov esi,0121000h
add esi,eax
mov eax,actpage
mov al,7
mov es:[esi],eax
mov ah,3
mov esi,0120000h
mov cr3,esi
int 033h			;Load page
;mov ah,4
;xor bh,bh
;mov bl,oldest
;int 032h
popad
pop es
pop ds
add esp,4
iretd

_pagefault:
popad
pop es
pop ds
pushad
mov esi,offset excmsg_e
jmp near ptr advancedf

