;**************************************
;Kernel's include file
;Advanced Exception information
;Copyright (1995-1996) the Kayma company
;***************************************

advancedf:
cli
mov dx,1
jmp _contn
advancedt:
cli
xor dx,dx
_contn:
mov eax,cr0
btr eax,18
mov cr0,eax
push ds
push es
mov ax,010h
mov ds,ax
mov exc,1
mov ax,018h
mov es,ax
lidt ds:fword ptr [offset IDT_PTR]
mov dpmiv86,0
mov ax,fs
mov v86_fs,ax
mov ax,gs
mov v86_gs,ax
mov ax,0703h
int 032h
mov ds:dword ptr msgno,esi
mov ebp,esp
add ebp,4
mov eax,ss:[ebp+44]
bt eax,17		;Was it from V86 mode?
jnc _pmodeexc
mov dx,1
_pmodeexc:
cmp dx,1
je _contn1
pop ax
mov v86_es,ax
pop ax
mov v86_ds,ax
popad
push 0
push 0
pushad
mov ax,v86_ds
push ax
mov ax,v86_es
push ax
_contn1:
mov ebp,esp
add ebp,4
mov eax,ss:[ebp+48]
mov ds:dword ptr [offset oesp],eax
mov eax,ss:[ebp+44]	;Eflags
bt eax,17
jc _virtualmode
;Protected mode exception
mov eax,ss:[ebp+40]
and ax,3
mov ds:word ptr level,ax
cmp ax,0		;Level 0 code?
jne _user
pop ax		;ES
mov v86_es,ax
pop ax		;DS
mov v86_ds,ax
mov ax,fs
mov v86_fs,ax
mov ax,gs
mov v86_gs,ax
mov ax,ss
mov v86_ss,ax
mov eax,ds:dword ptr oesp
add eax,0ch
mov v86_esp,eax
mov eax,ss:[ebp+28]
mov v86_eax,eax
mov eax,ss:[ebp+16]
mov v86_ebx,eax
mov eax,ss:[ebp+24]
mov v86_ecx,eax
mov eax,ss:[ebp+20]
mov v86_edx,eax
mov eax,ss:[ebp+8]
mov v86_ebp,eax
mov eax,ss:[ebp+4]
mov v86_esi,eax
mov eax,ss:[ebp]
mov v86_edi,eax
mov eax,ss:[ebp+44]
mov v86_eflags,eax
mov eax,ss:[ebp+40]
mov v86_cs,ax
mov eax,ss:[ebp+36]
mov v86_eip,eax
mov esi,offset GDT
movzx eax,v86_cs
and ax,0fff8h
add esi,eax
mov eax,ds:[esi]
mov ds:dword ptr [offset GDTcodetmp],eax
mov eax,ds:[esi+4]
mov ah,092h
mov ds:dword ptr [offset GDTcodetmp+4],eax
mov esi,v86_eip
mov ax,040h
mov ds,ax
mov eax,ds:[esi]
mov bx,010h
mov ds,bx
mov v86_xxx,eax
mov v86_err,0
mov ax,v86_ss
mov es,ax
mov edi,v86_esp
;mov eax,es:[edi]
mov bx,018h
mov es,bx
mov ds:dword ptr stac,eax
jmp _regsok
_virtualmode:
pop eax		;PUSHED DS,ES
mov eax,ss:[ebp+32]
mov v86_err,eax
mov eax,ss:[ebp+28]
mov v86_eax,eax
mov eax,ss:[ebp+16]
mov v86_ebx,eax
mov eax,ss:[ebp+24]
mov v86_ecx,eax
mov eax,ss:[ebp+20]
mov v86_edx,eax
mov eax,ss:[ebp+8]
mov v86_esp,eax
mov eax,ss:[ebp+4]
mov v86_esi,eax
mov eax,ss:[ebp]
mov v86_edi,eax
mov eax,ss:[ebp+68]
mov v86_gs,ax
mov eax,ss:[ebp+64]
mov v86_fs,ax
mov eax,ss:[ebp+60]
mov v86_ds,ax
mov eax,ss:[ebp+56]
mov v86_es,ax
mov eax,ss:[ebp+52]
mov v86_ss,ax
mov eax,ss:[ebp+48]
mov v86_esp,eax
mov eax,ss:[ebp+44]
mov v86_eflags,eax
mov eax,ss:[ebp+40]
mov v86_cs,ax
mov eax,ss:[ebp+36]
mov v86_eip,eax
movzx eax,v86_cs
shl eax,4
add eax,v86_eip
mov edi,eax
mov eax,es:[edi]
mov v86_xxx,eax
mov eax,ss:[ebp+36]
mov v86_err,eax
mov ds:word ptr level,4
jmp _regsok
_user:
pop ax
mov v86_es,ax
pop ax
mov v86_ds,ax
mov eax,ss:[ebp+32]
mov v86_err,eax
mov eax,ss:[ebp+28]
mov v86_eax,eax
mov eax,ss:[ebp+16]
mov v86_ebx,eax
mov eax,ss:[ebp+24]
mov v86_ecx,eax
mov eax,ss:[ebp+20]
mov v86_edx,eax
mov eax,ss:[ebp+8]
mov v86_esp,eax
mov eax,ss:[ebp+4]
mov v86_esi,eax
mov eax,ss:[ebp]
mov v86_edi,eax
mov eax,ss:[ebp+36]
mov v86_eip,eax
mov ax,ss:[ebp+40]
mov v86_cs,ax
mov eax,ss:[ebp+44]
mov v86_eflags,eax
mov ax,ss:[ebp+52]
mov v86_ss,ax
mov eax,ss:[ebp+48]
mov v86_esp,eax
mov eax,ss:[ebp+8]
mov v86_ebp,eax

mov ax,v86_cs
call _maketmpsel
mov esi,v86_eip
mov ax,040h
mov es,ax
mov eax,es:[esi]
mov bx,018h
mov es,bx
mov v86_xxx,eax
mov ax,v86_ss
call _maketmpsel
mov esi,v86_esp
mov ax,040h
mov es,ax
mov eax,es:[esi]
mov bx,018h
mov es,bx
mov ds:dword ptr stac,eax
jmp _regsok

_maketmpsel:
movzx eax,ax
mov bx,ax
and bx,4
cmp bx,4
jne _gdtcode
and ax,0FFF8h
mov esi,011a000h
add esi,eax
jmp _contcodemake
_gdtcode:
and ax,0FFF8h
mov esi,0110000h
mov ecx,offset GDT
add esi,ecx
add esi,eax
_contcodemake:
mov eax,es:[esi]
mov dword ptr ds:[offset GDTcodetmp],eax
mov eax,es:[esi+4]
mov ah,092h
mov dword ptr ds:[offset GDTcodetmp+4],eax
retn

_regsok:
;mov ax,0703h
;int 032h
xor ax,ax
int 032h
cmp word ptr level,0
jne _nointernal
mov color,12
mov ah,3
mov esi,offset internal
int 032h
mov bx,v86_cs
cmp bx,8
jne _nomain
mov esi,offset MAIN
int 032h
_nomain:
_nointernal:
mov color,14
mov esi,offset excmsg
mov ah,3
int 032h
mov esi,ds:dword ptr msgno
int 032h
mov color,7
mov esi,offset advtxt
int 032h
mov bx,ds:word ptr level
cmp bx,4
jne _novmode
mov esi,offset rltxt
mov ah,3
int 032h
jmp _cont1
_novmode:
mov esi,offset prtxt
int 032h
mov ah,4
int 032h
_cont1:
mov esi,offset error_txt
mov ah,3
int 032h
mov ebx,ds:v86_err
cmp ebx,0
je _noerrc
mov ah,5
int 032h
jmp _cont2
_noerrc:
mov esi,offset none
int 032h
_cont2:
mov esi,offset regtxt
mov ah,3
int 032h
jmp _cont3
_regout32:
mov ah,3
int 032h
mov ah,5
int 032h
retn
_regout16:
mov ah,3
int 032h
mov ah,4
int 032h
retn
_cont3:
mov esi,offset r_eax
mov ebx,v86_eax
call _regout32
mov esi,offset r_ebx
mov ebx,v86_ebx
call _regout32
mov esi,offset r_ecx
mov ebx,v86_ecx
call _regout32
mov esi,offset r_edx
mov ebx,v86_edx
call _regout32
mov esi,offset r_cr2
mov ebx,cr2
call _regout32
mov esi,offset r_esi
mov ebx,v86_esi
call _regout32
mov esi,offset r_edi
mov ebx,v86_edi
call _regout32
mov esi,offset r_ebp
mov ebx,v86_ebp
call _regout32
mov esi,offset r_cr0
mov ebx,cr0
call _regout32
mov esi,offset r_cr3
mov ebx,cr3
call _regout32
mov esi,offset r_flg
mov ah,3
int 032h
mov ebx,v86_eflags
mov ah,8
int 032h
mov esi,offset flags_rem
mov ah,3
int 032h

mov esi,offset r_ds
mov bx,v86_ds
call _regout16
mov esi,offset r_es
mov bx,v86_es
call _regout16
mov esi,offset r_fs
mov bx,v86_fs
call _regout16
mov esi,offset r_gs
mov bx,v86_gs
call _regout16
mov esi,offset r_ld
sldt bx
call _regout16
mov esi,offset r_tr
str bx
call _regout16
mov esi,offset r_ss
mov bx,v86_ss
call _regout16
mov esi,offset r_esp
mov ebx,v86_esp
call _regout32
mov esi,offset stc_code
mov ebx,ds:dword ptr stac
call _regout32
mov esi,offset r_cs
mov bx,v86_cs
call _regout16
mov esi,offset r_eip
mov ebx,v86_eip
call _regout32
mov esi,offset r_ic
mov eax,v86_xxx
mov bx,ax
shr eax,16
mov cx,ax
xchg bl,bh
xchg cl,ch
mov ax,bx
shl eax,16
mov ax,cx
mov ebx,eax
call _regout32
mov bx,word ptr level
cmp bx,0
;jne _terminate
jmp _terminate
mov color,12
mov esi,offset halted
mov ah,3
int 032h
cli
hlt

_terminate:
mov al,036h
out 042h,al
xor al,al
out 040h,al
out 040h,al
mov esi,011F400h
mov edi,0
mov cx,256
cpybckirqb:
mov eax,es:[esi]
mov es:[edi],eax
add esi,4
add edi,4
loop cpybckirqb
in al,060h
mov al,061h
or al,080h
out 061h,al
and al,07fh
out 061h,al
mov al,020h
out 020h,al
out 0a0h,al
mov ah,3
mov esi,offset select
int 032h
mov esi,offset choice
int 032h
mov ds:byte ptr keybuff[20],0
sti
_waitt:
mov al,ds:keybuff[20]
cmp al,1
jne _waitt
call near ptr _freedpmimem
mov exc,0
mov v86_ax,3
mov ax,0110h
int 033h
mov v86_ax,04c00h
mov ax,0121h
int 033h
